package cz.zcu.fav.kiv.mjakubas.saf.config.configs;

import org.jetbrains.annotations.NotNull;

import java.io.IOException;
import java.util.Properties;

/**
 * Config containing all command flag values.
 */
public class CommandConfig {

    private Properties properties;

    /**
     * Creates new command config from {@link Properties} file.
     *
     * @param property command config {@link Properties} file
     * @return new {@link CommandConfig}
     */
    public static CommandConfig loadCommandConfig(@NotNull Properties property) {
        CommandConfig commandConfig = new CommandConfig();
        commandConfig.properties = property;

        return commandConfig;
    }

    /**
     * Get command config {@link Properties} properties file.
     * @return command config {@link Properties} file
     */
    public Properties getProperties() {
        return properties;
    }
}
