package cz.zcu.fav.kiv.mjakubas.saf.gui.alert;

import cz.zcu.fav.kiv.mjakubas.saf.gui.i18n.I18N;
import javafx.beans.property.SimpleStringProperty;
import javafx.scene.control.Alert;

/**
 * Defines custom alerts for application
 */
public class CustomAlerts {

    /**
     * Info alert.
     */
    public static void showInfoAlert(String localisedHeader, String localisedContent) {
        Alert infoAlert = new Alert(Alert.AlertType.INFORMATION);

        I18N i18N = I18N.getLocalizationTool();
        infoAlert.titleProperty().bind(i18N.createStringBinding("alert.title.information"));
        infoAlert.headerTextProperty().bind(i18N.createStringBinding(localisedHeader));
        infoAlert.contentTextProperty().bind(i18N.createStringBinding(localisedContent));

        infoAlert.showAndWait();
    }

    /**
     * Error alert.
     */
    public static void showErrorAlert(String localisedHeader, String errorMessage) {
        Alert errorAlert = new Alert(Alert.AlertType.ERROR);

        I18N i18N = I18N.getLocalizationTool();
        errorAlert.titleProperty().bind(i18N.createStringBinding("alert.title.error"));
        errorAlert.headerTextProperty().bind(i18N.createStringBinding(localisedHeader));
        errorAlert.contentTextProperty().bind(new SimpleStringProperty(errorMessage));

        errorAlert.showAndWait();
    }
}
