package cz.zcu.fav.kiv.mjakubas.saf.gui.controller.entity.entities;

import cz.zcu.fav.kiv.mjakubas.saf.config.configs.RequestConfig;
import cz.zcu.fav.kiv.mjakubas.saf.entity.Absence;
import cz.zcu.fav.kiv.mjakubas.saf.gui.controller.entity.AEntityController;
import cz.zcu.fav.kiv.mjakubas.saf.gui.controller.entity.EntitiesController;
import cz.zcu.fav.kiv.mjakubas.saf.gui.controller.entity.FetchException;
import cz.zcu.fav.kiv.mjakubas.saf.gui.form.nform.AForm;
import org.jetbrains.annotations.NotNull;

/**
 * Fetches and manages {@link Absence} connection between front-end and back-end.
 */
public class AbsenceEntityController extends AEntityController<Absence> {

    // constructor

    /**
     * Instantiates new {@link AEntityController} of certain entity with connection defined by {@link RequestConfig}.
     */
    public AbsenceEntityController(
            @NotNull AForm<Absence> entityForm,
            @NotNull EntitiesController entitiesController) {
        super(entityForm, entitiesController);
    }

    // override

    @Override
    protected String getBaseAddress() {
        return RequestConfig.ABSENCE_ENTITIES_QUERY;
    }

    @Override
    protected String getAdditionalAddress() {
        return null;
    }

    @Override
    protected Class<Absence> getEntityClass() {
        return Absence.class;
    }

    @Override
    protected void fetchAdditionalData() throws FetchException {
        for (Absence absence : fetchedEntities) {
            absence.setStudent(entitiesController.getStudentEntityController().getFetchedEntity(absence.getIdStudents()));
            absence.setScheduleactionsdate(entitiesController.getScheduleActionDateEntityController().getFetchedEntity(absence.getIdScheduleactiondates()));
        }
    }
}
