package cz.zcu.fav.kiv.mjakubas.saf.gui.controller.entity.entities;

import cz.zcu.fav.kiv.mjakubas.saf.config.configs.RequestConfig;
import cz.zcu.fav.kiv.mjakubas.saf.entity.SchoolClass;
import cz.zcu.fav.kiv.mjakubas.saf.entity.Subject;
import cz.zcu.fav.kiv.mjakubas.saf.gui.controller.entity.AEntityController;
import cz.zcu.fav.kiv.mjakubas.saf.gui.controller.entity.EntitiesController;
import cz.zcu.fav.kiv.mjakubas.saf.gui.controller.entity.FetchException;
import cz.zcu.fav.kiv.mjakubas.saf.gui.form.nform.AForm;
import org.jetbrains.annotations.NotNull;

import java.util.List;

/**
 * Fetches and manages {@link SchoolClass} connection between front-end and back-end.
 */
public class ClassEntityController extends AEntityController<SchoolClass> {

    // constructor

    /**
     * Instantiates new {@link AEntityController} of certain entity.
     */
    public ClassEntityController(
            @NotNull AForm<SchoolClass> entityForm,
            @NotNull EntitiesController entitiesController) {
        super(entityForm, entitiesController);
    }

    // override

    @Override
    protected String getBaseAddress() {
        return RequestConfig.CLASSES_ENTITIES_QUERY;
    }

    @Override
    protected String getAdditionalAddress() {
        return RequestConfig.SUBJECT_QUERY;
    }

    @Override
    protected Class<SchoolClass> getEntityClass() {
        return SchoolClass.class;
    }

    @Override
    protected void fetchAdditionalData() throws FetchException {
        List<Subject> fetchedSubjects = entitiesController.getSubjectEntityController().getAllFetchedEntities();
        for (SchoolClass s : fetchedEntities) {
            for (int i = 0; i < s.getSubjects().length; i++) {
                int j = i;
                s.getSubjects()[i] =
                        fetchedSubjects.stream().filter(x -> x.getID() == s.getSubjects()[j].getID()).toList().get(0);
            }
        }
    }
}
