package cz.zcu.fav.kiv.mjakubas.saf.gui.controller.entity.entities;

import cz.zcu.fav.kiv.mjakubas.saf.config.configs.RequestConfig;
import cz.zcu.fav.kiv.mjakubas.saf.entity.Evaluation;
import cz.zcu.fav.kiv.mjakubas.saf.entity.StudentsSubject;
import cz.zcu.fav.kiv.mjakubas.saf.gui.controller.entity.AEntityController;
import cz.zcu.fav.kiv.mjakubas.saf.gui.controller.entity.EntitiesController;
import cz.zcu.fav.kiv.mjakubas.saf.gui.controller.entity.FetchException;
import cz.zcu.fav.kiv.mjakubas.saf.gui.form.nform.AForm;
import org.jetbrains.annotations.NotNull;

import java.util.Arrays;
import java.util.List;

/**
 * Fetches and manages {@link Evaluation} connection between front-end and back-end.
 */
public class EvaluationEntityController extends AEntityController<Evaluation> {

    // constructor

    /**
     * Instantiates new {@link AEntityController} of certain entity.
     */
    public EvaluationEntityController(
            @NotNull AForm<Evaluation> entityForm,
            @NotNull EntitiesController entitiesController) {
        super(entityForm, entitiesController);
    }

    // override

    @Override
    protected String getBaseAddress() {
        return RequestConfig.EVALUATIONS_ENTITIES_QUERY;
    }

    @Override
    protected String getAdditionalAddress() {
        return null;
    }

    @Override
    protected Class<Evaluation> getEntityClass() {
        return Evaluation.class;
    }

    @Override
    protected void fetchAdditionalData() throws FetchException {
        List<StudentsSubject> studentsSubjectList =
                entitiesController.getStudentsSubjectEntityController().getAllFetchedEntities();

        for (Evaluation evaluation : fetchedEntities) {
            for (StudentsSubject studentsSubject : studentsSubjectList) {
                Evaluation[] evaluations = studentsSubject.getEvaluations();
                Evaluation[] f =
                        Arrays.stream(evaluations).filter(x -> x.getID() == evaluation.getID()).toList().toArray(new Evaluation[0]);
                if (f.length != 0) {
                    evaluation.setStudentssubject(studentsSubject);
                    break;
                }
            }
        }
    }
}
