package cz.zcu.fav.kiv.mjakubas.saf.gui.controller.entity.entities;

import cz.zcu.fav.kiv.mjakubas.saf.config.configs.RequestConfig;
import cz.zcu.fav.kiv.mjakubas.saf.entity.Building;
import cz.zcu.fav.kiv.mjakubas.saf.entity.Room;
import cz.zcu.fav.kiv.mjakubas.saf.gui.controller.entity.AEntityController;
import cz.zcu.fav.kiv.mjakubas.saf.gui.controller.entity.EntitiesController;
import cz.zcu.fav.kiv.mjakubas.saf.gui.controller.entity.FetchException;
import cz.zcu.fav.kiv.mjakubas.saf.gui.form.nform.AForm;
import org.jetbrains.annotations.NotNull;

import java.util.Arrays;
import java.util.List;

/**
 * Fetches and manages {@link Room} connection between front-end and back-end.
 */
public class RoomEntityController extends AEntityController<Room> {

    // constructor

    /**
     * Instantiates new {@link AEntityController} of certain entity.
     */
    public RoomEntityController(
            @NotNull AForm<Room> entityForm,
            @NotNull EntitiesController entitiesController) {
        super(entityForm, entitiesController);
    }

    // override

    @Override
    protected String getBaseAddress() {
        return RequestConfig.ROOMS_ENTITIES_QUERY;
    }

    @Override
    protected String getAdditionalAddress() {
        return null;
    }

    @Override
    protected Class<Room> getEntityClass() {
        return Room.class;
    }

    @Override
    protected void fetchAdditionalData() throws FetchException {
        List<Building> buildingList =
                EntitiesController.getEntitiesController().getBuildingEntityController().getAllFetchedEntities();

        for (Room room : fetchedEntities) {
            for (Building building : buildingList) {
                Room[] rooms = building.getRooms();
                Room[] f = Arrays.stream(rooms).filter(x -> x.getID() == room.getID()).toList().toArray(new Room[0]);
                if (f.length != 0) {
                    room.setBuilding(building);
                    break;
                }
            }
        }
    }
}
