package cz.zcu.fav.kiv.mjakubas.saf.gui.controller.entity.entities;

import cz.zcu.fav.kiv.mjakubas.saf.config.configs.RequestConfig;
import cz.zcu.fav.kiv.mjakubas.saf.entity.*;
import cz.zcu.fav.kiv.mjakubas.saf.gui.controller.entity.AEntityController;
import cz.zcu.fav.kiv.mjakubas.saf.gui.controller.entity.EntitiesController;
import cz.zcu.fav.kiv.mjakubas.saf.gui.controller.entity.FetchException;
import cz.zcu.fav.kiv.mjakubas.saf.gui.form.nform.AForm;
import org.jetbrains.annotations.NotNull;

import java.util.List;

/**
 * Fetches and manages {@link ScheduleActionDate} connection between front-end and back-end.
 */
public class ScheduleActionDateEntityController extends AEntityController<ScheduleActionDate> {

    /**
     * Instantiates new {@link AEntityController} of certain entity.
     */
    public ScheduleActionDateEntityController(
            @NotNull AForm<ScheduleActionDate> entityForm,
            @NotNull EntitiesController entitiesController) {
        super(entityForm, entitiesController);
    }

    @Override
    protected String getBaseAddress() {
        return RequestConfig.SCHEDULEACTIONDATES_ENTITIES_QUERY;
    }

    @Override
    protected String getAdditionalAddress() {
        return null;
    }

    @Override
    protected Class<ScheduleActionDate> getEntityClass() {
        return ScheduleActionDate.class;
    }

    @Override
    protected void fetchAdditionalData() throws FetchException {
        List<ScheduleAction> scheduleActionList =
                entitiesController.getScheduleActionEntityController().getAllFetchedEntities();

        for (ScheduleActionDate scheduleActionDate : fetchedEntities) {
            ScheduleAction scheduleAction =
                    scheduleActionList.stream().filter(x -> x.getIdScheduleactions() == scheduleActionDate.getIdScheduleactions()).toList().get(0);
            scheduleActionDate.setScheduleaction(scheduleAction);
        }
    }
}
