package cz.zcu.fav.kiv.mjakubas.saf.gui.controller.entity.entities;

import cz.zcu.fav.kiv.mjakubas.saf.config.configs.RequestConfig;
import cz.zcu.fav.kiv.mjakubas.saf.entity.*;
import cz.zcu.fav.kiv.mjakubas.saf.gui.controller.entity.AEntityController;
import cz.zcu.fav.kiv.mjakubas.saf.gui.controller.entity.EntitiesController;
import cz.zcu.fav.kiv.mjakubas.saf.gui.controller.entity.FetchException;
import cz.zcu.fav.kiv.mjakubas.saf.gui.form.nform.AForm;
import org.jetbrains.annotations.NotNull;

import java.util.List;

/**
 * Fetches and manages {@link ScheduleAction} connection between front-end and back-end.
 */
public class ScheduleActionEntityController extends AEntityController<ScheduleAction> {

    // constructor

    /**
     * Instantiates new {@link AEntityController} of certain entity with connection defined by {@link RequestConfig}.
     */
    public ScheduleActionEntityController(
            @NotNull AForm<ScheduleAction> entityForm,
            @NotNull EntitiesController entitiesController) {
        super(entityForm, entitiesController);
    }

    // override

    @Override
    protected String getBaseAddress() {
        return RequestConfig.SCHEDULEACTIONS_ENTITIES_QUERY;
    }

    @Override
    protected String getAdditionalAddress() {
        return null;
    }

    @Override
    protected Class<ScheduleAction> getEntityClass() {
        return ScheduleAction.class;
    }

    @Override
    protected void fetchAdditionalData() throws FetchException {
        List<Room> roomList =
                entitiesController.getRoomEntityController().getAllFetchedEntities();
        List<Subject> subjectList =
                entitiesController.getSubjectEntityController().getAllFetchedEntities();
        List<SchoolDay> schoolDayList =
                entitiesController.getSchoolDayEntityController().getAllFetchedEntities();
        List<SchoolHour> schoolHourList =
                entitiesController.getSchoolHourEntityController().getAllFetchedEntities();

        for (ScheduleAction scheduleAction : fetchedEntities) {
            Room room =
                    roomList.stream().filter(x -> x.getIdRooms() == scheduleAction.getIdRooms()).toList().get(0);
            scheduleAction.setRoom(room);
            Subject subject =
                    subjectList.stream().filter(x -> x.getIdSubjects() == scheduleAction.getIdSubjects()).toList().get(0);
            scheduleAction.setSubject(subject);
            SchoolDay schoolDay =
                    schoolDayList.stream().filter(x -> x.getIdSchooldays() == scheduleAction.getIdSchooldays()).toList().get(0);
            scheduleAction.setSchoolday(schoolDay);
            SchoolHour schoolHour =
                    schoolHourList.stream().filter(x -> x.getIdSchoolhours() == scheduleAction.getIdSchoolhours()).toList().get(0);
            scheduleAction.setSchoolhour(schoolHour);
        }
    }
}
