package cz.zcu.fav.kiv.mjakubas.saf.gui.controller.entity.entities;

import cz.zcu.fav.kiv.mjakubas.saf.config.configs.RequestConfig;
import cz.zcu.fav.kiv.mjakubas.saf.entity.*;
import cz.zcu.fav.kiv.mjakubas.saf.gui.controller.entity.AEntityController;
import cz.zcu.fav.kiv.mjakubas.saf.gui.controller.entity.EntitiesController;
import cz.zcu.fav.kiv.mjakubas.saf.gui.controller.entity.FetchException;
import cz.zcu.fav.kiv.mjakubas.saf.gui.form.nform.AForm;
import org.jetbrains.annotations.NotNull;

import java.util.Arrays;
import java.util.List;

/**
 * Fetches and manages {@link StudentsSubject} connection between front-end and back-end.
 */
public class StudentsSubjectEntityController extends AEntityController<StudentsSubject> {

    // constructor

    /**
     * Instantiates new {@link AEntityController} of certain entity.
     */
    public StudentsSubjectEntityController(
            @NotNull AForm<StudentsSubject> entityForm,
            @NotNull EntitiesController entitiesController) {
        super(entityForm, entitiesController);
    }

    // override

    @Override
    protected String getBaseAddress() {
        return RequestConfig.STUDENTSSUBJECTS_ENTITIES_QUERY;
    }

    @Override
    protected String getAdditionalAddress() {
        return null;
    }

    @Override
    protected Class<StudentsSubject> getEntityClass() {
        return StudentsSubject.class;
    }

    @Override
    protected void fetchAdditionalData() throws FetchException {
        List<Student> studentList =
                entitiesController.getStudentEntityController().getAllFetchedEntities();

        List<Subject> subjectList =
                entitiesController.getSubjectEntityController().getAllFetchedEntities();

        for (StudentsSubject studentsSubject : fetchedEntities) {
            for (Student student : studentList) {
                List<StudentsSubject> f =
                        Arrays.stream(student.getStudentssubjects()).filter(x -> x.getIdStudentssubjects() == studentsSubject.getID()).toList();
                if (f.size() != 0) {
                    studentsSubject.setStudent(student);
                    break;
                }
            }

            for (Subject subject : subjectList) {
                List<StudentsSubject> f =
                        Arrays.stream(subject.getStudentssubjects()).filter(x -> x.getIdStudentssubjects() == studentsSubject.getID()).toList();
                if (f.size() != 0) {
                    studentsSubject.setSubject(subject);
                    break;
                }
            }
        }
    }
}
