package cz.zcu.fav.kiv.mjakubas.saf.gui.controller.entity.entities;

import cz.zcu.fav.kiv.mjakubas.saf.config.configs.RequestConfig;
import cz.zcu.fav.kiv.mjakubas.saf.entity.SubjectList;
import cz.zcu.fav.kiv.mjakubas.saf.gui.controller.entity.AEntityController;
import cz.zcu.fav.kiv.mjakubas.saf.gui.controller.entity.EntitiesController;
import cz.zcu.fav.kiv.mjakubas.saf.gui.controller.entity.FetchException;
import cz.zcu.fav.kiv.mjakubas.saf.gui.form.nform.AForm;
import org.jetbrains.annotations.NotNull;

/**
 * Fetches and manages {@link SubjectList} connection between front-end and back-end.
 */
public class SubjectListEntityController extends AEntityController<SubjectList> {

    // constructor

    /**
     * Instantiates new {@link AEntityController} of certain entity.
     */
    public SubjectListEntityController(
            @NotNull AForm<SubjectList> entityForm,
            @NotNull EntitiesController entitiesController) {
        super(entityForm, entitiesController);
    }

    // override

    @Override
    protected String getBaseAddress() {
        return RequestConfig.SUBJECTLISTS_ENTITIES_QUERY;
    }

    @Override
    protected String getAdditionalAddress() {
        return null;
    }

    @Override
    protected Class<SubjectList> getEntityClass() {
        return SubjectList.class;
    }

    @Override
    protected void fetchAdditionalData() throws FetchException {

    }
}
