package cz.zcu.fav.kiv.mjakubas.saf.gui.controller.entity.entities;

import cz.zcu.fav.kiv.mjakubas.saf.config.configs.RequestConfig;
import cz.zcu.fav.kiv.mjakubas.saf.entity.Teacher;
import cz.zcu.fav.kiv.mjakubas.saf.gui.controller.entity.AEntityController;
import cz.zcu.fav.kiv.mjakubas.saf.gui.controller.entity.EntitiesController;
import cz.zcu.fav.kiv.mjakubas.saf.gui.controller.entity.FetchException;
import cz.zcu.fav.kiv.mjakubas.saf.gui.form.nform.AForm;
import org.jetbrains.annotations.NotNull;

/**
 * Fetches and manages {@link Teacher} connection between front-end and back-end.
 */
public class TeacherEntityController extends AEntityController<Teacher> {

    // constructor

    /**
     * Instantiates new {@link AEntityController} of certain entity.
     */
    public TeacherEntityController(
            @NotNull AForm<Teacher> entityForm,
            @NotNull EntitiesController entitiesController) {
        super(entityForm, entitiesController);
    }

    // override

    @Override
    protected String getBaseAddress() {
        return RequestConfig.TEACHERS_ENTITIES_QUERY;
    }

    @Override
    protected String getAdditionalAddress() {
        return RequestConfig.SUBJECTLIST_QUERY;
    }

    @Override
    protected Class<Teacher> getEntityClass() {
        return Teacher.class;
    }

    @Override
    protected void fetchAdditionalData() throws FetchException {

    }
}
