package cz.zcu.fav.kiv.mjakubas.saf.gui.form.nform;

import com.dlsc.formsfx.model.structure.Field;
import com.dlsc.formsfx.model.structure.Form;
import com.dlsc.formsfx.model.structure.Group;
import com.dlsc.formsfx.view.renderer.FormRenderer;
import cz.zcu.fav.kiv.mjakubas.saf.entity.StudentsSubject;
import cz.zcu.fav.kiv.mjakubas.saf.gui.controller.entity.AEntityController;
import cz.zcu.fav.kiv.mjakubas.saf.gui.form.nmodel.IModel;
import cz.zcu.fav.kiv.mjakubas.saf.gui.form.nmodel.StudentsSubjectModel;
import cz.zcu.fav.kiv.mjakubas.saf.gui.i18n.I18N;
import javafx.geometry.Pos;
import javafx.scene.control.Label;
import javafx.scene.layout.HBox;
import javafx.scene.layout.Pane;
import javafx.scene.layout.VBox;
import org.jetbrains.annotations.NotNull;

/**
 * Represent all possible forms of {@link StudentsSubject} entity.
 */
public class StudentSubjectForm extends AForm<StudentsSubject> {
    @Override
    protected AEntityController<?> getEntityController() {
        return null;
    }

    @Override
    protected Form createPostForm(IModel<StudentsSubject> entityModel) {
        return Form.of();
    }

    @Override
    protected Pane createPostPane(Form postForm) {
        VBox vBox = new VBox();
        Label cannotCreate = new Label();
        cannotCreate.textProperty().bind(I18N.getLocalizationTool().createStringBinding("cannot.create.property.label"));
        cannotCreate.setAlignment(Pos.CENTER);
        HBox mid = new HBox();
        mid.setAlignment(Pos.CENTER);
        mid.getChildren().addAll(cannotCreate);
        vBox.getChildren().addAll(mid);
        return vBox;
    }

    @Override
    protected Form createEditablePutForm(IModel<StudentsSubject> entityModel) {
        StudentsSubjectModel model = (StudentsSubjectModel) entityModel;
        return Form.of(
                Group.of(
                        Field.ofIntegerType(model.studentsSubjectIDProperty())
                                .label("form.label.id")
                                .editable(false)
                )
        ).i18n(I18N.getLocalizationTool().getResourceBundleService());
    }

    @Override
    protected Pane createEditablePutPane(Form editablePutForm) {
        return new FormRenderer(editablePutForm);
    }

    @Override
    protected Form createAdditionalPutForm(IModel<?> entityModel) {
        return null;
    }


    @Override
    protected Pane createNonEditablePutPane(Form nonEditablePutForm) {
        return null;
    }

    @Override
    protected Form createAdditionalDeletePutForm(IModel<?> entityModel) {
        return null;
    }

    @Override
    protected Pane createNonEditableDeletePutPane(Form nonEditablePutForm) {
        return null;
    }

    @Override
    protected IModel<StudentsSubject> createEmptyModel() {
        return new StudentsSubjectModel();
    }

    @Override
    protected IModel<StudentsSubject> createEntityModel(@NotNull StudentsSubject entity) {
        IModel<StudentsSubject> studentsSubjectModelModel = new StudentsSubjectModel();
        studentsSubjectModelModel.importEntity(entity);
        return studentsSubjectModelModel;
    }

    @Override
    protected IModel<?> createAdditionalModel() {
        return null;
    }

    @Override
    protected Object getAdditionalEntity(IModel<StudentsSubject> additionalModel) {
        return null;
    }
}
