package cz.zcu.fav.kiv.mjakubas.saf.gui.form.nmodel;

import cz.zcu.fav.kiv.mjakubas.saf.entity.Building;
import cz.zcu.fav.kiv.mjakubas.saf.entity.Room;
import javafx.beans.property.*;
import javafx.collections.FXCollections;

/**
 * Represents a model object of a building entity.
 */
public class BuildingModel implements IModel<Building> {
    private final IntegerProperty buildingID = new SimpleIntegerProperty(0);
    private final StringProperty buildingName = new SimpleStringProperty("");

    private final ListProperty<Room> allBuildingRooms = new SimpleListProperty<>(FXCollections.observableArrayList());

    // override

    @Override
    public void importEntity(Building entity) {
        this.buildingID.set(entity.getID());
        this.buildingName.set(entity.getBuildingName());
        this.allBuildingRooms.addAll(entity.getRooms());
    }

    @Override
    public Building exportEntity() {
        return new Building(buildingID.getValue(), buildingName.getValue(), null);
    }

    // get

    /**
     * Gets building entity id.
     *
     * @return building entity id
     */
    public IntegerProperty buildingIDProperty() {
        return buildingID;
    }

    /**
     * Gets building entity name.
     *
     * @return building entity name
     */
    public StringProperty buildingNameProperty() {
        return buildingName;
    }

    public ListProperty<Room> allBuildingRoomsProperty() {
        return allBuildingRooms;
    }
}
