package cz.zcu.fav.kiv.mjakubas.saf.gui.form.nmodel;

import cz.zcu.fav.kiv.mjakubas.saf.gui.controller.entity.FetchException;

/**
 * Defines an interface for a model used in a form as a data holder.
 *
 * @param <E> entity
 */
public interface IModel<E> {

    /**
     * Imports entity field to model.
     *
     * @param entity reference entity
     */
    void importEntity(E entity);

    /**
     * Exports entity from model.
     *
     * @return entity from model
     */
    E exportEntity();

    default void fillAdditionalEntities() throws FetchException {
    }

    default void makeAdditionalRequests() {
        try {
            fillAdditionalEntities();
        } catch (FetchException e) {
            throw new RuntimeException(e);
        }
    }
}
