package cz.zcu.fav.kiv.mjakubas.saf.request.basicrequest;

/**
 * Represents a result of a http request.
 */
public class HttpResponseResult {

    private final int responseCode;
    private final String response;

    /**
     * Creates new instance of {@link HttpResponseResult} that represents a result of http request.
     *
     * @param responseCode http response code
     * @param response     http response message
     */
    public HttpResponseResult(int responseCode, String response) {
        this.responseCode = responseCode;
        this.response = response;
    }

    /**
     * Gets response code.
     *
     * @return response code
     */
    public int getResponseCode() {
        return responseCode;
    }

    /**
     * Gets response message.
     *
     * @return response message
     */
    public String getResponse() {
        return response;
    }
}