package cz.zcu.fav.kiv.mjakubas.saf.request.basicrequest.requests;

import cz.zcu.fav.kiv.mjakubas.saf.request.basicrequest.ABasicHttpRequest;
import org.jetbrains.annotations.NotNull;

import java.net.Authenticator;
import java.net.URI;
import java.net.http.HttpRequest;

/**
 * Represents a http delete method as a request.
 * Allows to create a basic template for one specific http delete request that can be called continuously.
 */
public class HttpDeleteRequest extends ABasicHttpRequest {

    /**
     * Creates a basic template for one http delete request. Request can be called continuously.
     *
     * @param uri           http request target uri
     * @param authenticator authentication method
     */
    public HttpDeleteRequest(@NotNull URI uri, @NotNull Authenticator authenticator) {
        super(uri, authenticator);
    }

    @Override
    protected HttpRequest buildRequest(String body) throws NullPointerException {
        return HttpRequest.newBuilder()
                .uri(uri)
                .headers("Content-Type", "application/json")
                .DELETE()
                .build();
    }
}
