package cz.zcu.fav.kiv.mjakubas.saf.config.configs;

import cz.zcu.fav.kiv.mjakubas.saf.config.ConfigManager;
import cz.zcu.fav.kiv.mjakubas.saf.io.properties.PropertiesIO;
import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;

import java.io.IOException;
import java.util.Properties;

/**
 * Test for {@link CommandConfig} class and its properties values.
 */
class CommandConfigTest {

    Properties properties;

    @BeforeEach
    void setUp() throws Exception {
        properties = ConfigManager.getManager().getCommandConfig().getProperties();
    }

    @Test
    void value1() throws IOException {
        String val = PropertiesIO.getValue(properties, "query.absences");
        Assertions.assertEquals("absences", val);
    }

    @Test
    void value2() throws IOException {
        String val = PropertiesIO.getValue(properties, "query.buildings");
        Assertions.assertEquals("buildings", val);
    }

    @Test
    void value3() throws IOException {
        String val = PropertiesIO.getValue(properties, "query.classes");
        Assertions.assertEquals("classes", val);
    }

    @Test
    void value4() throws IOException {
        String val = PropertiesIO.getValue(properties, "query.evaluations");
        Assertions.assertEquals("evaluations", val);
    }

    @Test
    void value5() throws IOException {
        String val = PropertiesIO.getValue(properties, "query.rooms");
        Assertions.assertEquals("rooms", val);
    }

    @Test
    void value6() throws IOException {
        String val = PropertiesIO.getValue(properties, "query.scheduleActions");
        Assertions.assertEquals("scheduleActions", val);
    }

    @Test
    void value7() throws IOException {
        String val = PropertiesIO.getValue(properties, "query.scheduleActionsDates");
        Assertions.assertEquals("scheduleActionsDates", val);
    }

    @Test
    void value8() throws IOException {
        String val = PropertiesIO.getValue(properties, "query.schoolDays");
        Assertions.assertEquals("schoolDays", val);
    }

    @Test
    void value9() throws IOException {
        String val = PropertiesIO.getValue(properties, "query.schoolHours");
        Assertions.assertEquals("schoolHours", val);
    }

    @Test
    void value10() throws IOException {
        String val = PropertiesIO.getValue(properties, "query.students");
        Assertions.assertEquals("students", val);
    }

    @Test
    void value11() throws IOException {
        String val = PropertiesIO.getValue(properties, "query.studentsSubjects");
        Assertions.assertEquals("studentsSubjects", val);
    }

    @Test
    void value12() throws IOException {
        String val = PropertiesIO.getValue(properties, "query.schoolHours");
        Assertions.assertEquals("schoolHours", val);
    }

    @Test
    void value13() throws IOException {
        String val = PropertiesIO.getValue(properties, "query.subjects");
        Assertions.assertEquals("subjects", val);
    }

    @Test
    void value14() throws IOException {
        String val = PropertiesIO.getValue(properties, "query.subjectLists");
        Assertions.assertEquals("subjectLists", val);
    }

    @Test
    void value15() throws IOException {
        String val = PropertiesIO.getValue(properties, "query.teachers");
        Assertions.assertEquals("teachers", val);
    }

    @Test
    void value16() throws IOException {
        String val = PropertiesIO.getValue(properties, "query.sub.getAll");
        Assertions.assertEquals("--all", val);
    }

    @Test
    void value17() throws IOException {
        String val = PropertiesIO.getValue(properties, "query.sub.byStudent");
        Assertions.assertEquals("--student", val);
    }

    @Test
    void value18() throws IOException {
        String val = PropertiesIO.getValue(properties, "query.sub.bySurname");
        Assertions.assertEquals("--surname", val);
    }

    @Test
    void value19() throws IOException {
        String val = PropertiesIO.getValue(properties, "query.sub.byScheduleActionDate");
        Assertions.assertEquals("--scheduleActionDate", val);
    }

    @Test
    void value20() throws IOException {
        String val = PropertiesIO.getValue(properties, "query.sub.byRoom");
        Assertions.assertEquals("--room", val);
    }

    @Test
    void value21() throws IOException {
        String val = PropertiesIO.getValue(properties, "query.sub.byTeacher");
        Assertions.assertEquals("--teacher", val);
    }

    @Test
    void value22() throws IOException {
        String val = PropertiesIO.getValue(properties, "query.sub.bySubject");
        Assertions.assertEquals("--subject", val);
    }

    @Test
    void value23() throws IOException {
        String val = PropertiesIO.getValue(properties, "query.sub.byStudentsSubject");
        Assertions.assertEquals("--studentsSubject", val);
    }

    @Test
    void value24() throws IOException {
        String val = PropertiesIO.getValue(properties, "query.sub.byCapacity");
        Assertions.assertEquals("--capacity", val);
    }

    @Test
    void value25() throws IOException {
        String val = PropertiesIO.getValue(properties, "query.sub.byBuilding");
        Assertions.assertEquals("--building", val);
    }

    @Test
    void value26() throws IOException {
        String val = PropertiesIO.getValue(properties, "query.sub.byClass");
        Assertions.assertEquals("--class", val);
    }

    @Test
    void value27() throws IOException {
        String val = PropertiesIO.getValue(properties, "query.sub.bySubstitutions");
        Assertions.assertEquals("--substitutions", val);
    }

    @Test
    void value28() throws IOException {
        String val = PropertiesIO.getValue(properties, "query.sub.byScheduleAction");
        Assertions.assertEquals("--scheduleAction", val);
    }

    @Test
    void value29() throws IOException {
        String val = PropertiesIO.getValue(properties, "query.sub.bySubjectList");
        Assertions.assertEquals("--subjectList", val);
    }

    @Test
    void value30() throws IOException {
        String val = PropertiesIO.getValue(properties, "query.sub.doRemove");
        Assertions.assertEquals("remove", val);
    }

    @Test
    void value31() throws IOException {
        String val = PropertiesIO.getValue(properties, "query.sub.doAdd");
        Assertions.assertEquals("add", val);
    }

    @Test
    void value32() throws IOException {
        String val = PropertiesIO.getValue(properties, "query.sub.type.XML");
        Assertions.assertEquals("--xml", val);
    }

    @Test
    void value33() throws IOException {
        String val = PropertiesIO.getValue(properties, "query.sub.type.JSON");
        Assertions.assertEquals("--json", val);
    }

    @Test
    void value34() throws IOException {
        String val = PropertiesIO.getValue(properties, "httpMethod.get");
        Assertions.assertEquals("--get", val);
    }

    @Test
    void value35() throws IOException {
        String val = PropertiesIO.getValue(properties, "httpMethod.post");
        Assertions.assertEquals("--post", val);
    }

    @Test
    void value36() throws IOException {
        String val = PropertiesIO.getValue(properties, "httpMethod.put");
        Assertions.assertEquals("--put", val);
    }

    @Test
    void value37() throws IOException {
        String val = PropertiesIO.getValue(properties, "httpMethod.delete");
        Assertions.assertEquals("--delete", val);
    }
}