package cz.zcu.fav.kiv.mjakubas.saf.io.file;

import org.junit.jupiter.api.AfterEach;
import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;

import java.nio.file.Files;
import java.nio.file.Path;

class FileIOTest {

    Path p;

    @BeforeEach
    void setUp() throws Exception {
        p = Path.of(this.getClass().getClassLoader().getResource("copy").toURI());
    }

    @AfterEach
    void tearDown() {
    }

    @Test
    void copyDirectory1() throws Exception {
        Path temp = Files.createTempFile("temp", "test-frontend");
        Assertions.assertDoesNotThrow(() -> FileIO.copyDirectory(temp.toFile().getAbsolutePath(),
                p.toFile().getAbsolutePath()));
    }

    @Test
    void copyDirectory2F() throws Exception {
        Path temp = Files.createTempFile("temp", "test-frontend");
        Assertions.assertDoesNotThrow(() -> FileIO.copyDirectory(temp.toFile().getAbsolutePath(),
                p.toFile().getAbsolutePath()));
        Assertions.assertDoesNotThrow(() -> FileIO.copyDirectory(temp.toFile().getAbsolutePath(),
                p.toFile().getAbsolutePath()));
    }

    @Test
    void copyDirectoryVoid() throws Exception {
        Assertions.assertThrows(Exception.class, () -> FileIO.copyDirectory("void",
                "void"));
    }
}